<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>hydra-obj</title>
    <script src="https://unpkg.com/hydra-synth"></script>
</head>

<body>

    <script>

        const hydraCanvas = document.createElement("CANVAS");
        // ctx=canvas.getContext("2d");
        hydraCanvas.width = window.innerWidth / 2.;
        hydraCanvas.height = window.innerHeight / 2.;
        var opt = {
            canvas: hydraCanvas, // canvas element to render to. If none is supplied, a canvas will be created and appended to the screen

            // width:window.innerWidth,// defaults to canvas width when included, 1280 if not

            // height: window.innerHeightnoise,// defaults to canvas height when included, 720 if not

            autoLoop: true, // if true, will automatically loop using requestAnimationFrame.If set to false, you must implement your own loop function using the tick() method (below)

            makeGlobal: true, // if false, will not pollute global namespace (note: there are currently bugs with this)

            detectAudio: false, // recommend setting this to false to avoid asking for microphone

            numSources: 4, // number of source buffers to create initially

            numOutputs: 4, // number of output buffers to use. Note: untested with numbers other than 4. render() method might behave unpredictably

            extendTransforms: [], // An array of transforms to be added to the synth, or an object representing a single transform

            precision: null,  // force precision of shaders, can be 'highp', 'mediump', or 'lowp' (recommended for ios). When no precision is specified, will use highp for ios, and mediump for everything else.

            pb: null, // instance of rtc-patch-bay to use for streaming
        }

        //   document.querySelector("#app").appendChild(canvas);

        const hydra = new Hydra(opt)



        document.body.appendChild(hydraCanvas);


        class HydraFactory {
            //en el fondo me gustaria entender el GeneratorFactory y hacer una herencia de esa clase
            //o en otro caso utilizar el parser de hydra desde un scritp 
            //GeneratorFactory //line 1396 y el GlslSource
            //podria ver de tomar una herencia? y agregarle los metodos de dict?

            //el problema actualmente esta en la perdida de modificaciones Y contador de las mismas?
            //o perdida referencia de contexto?? al estar warpeado en una clase

            constructor(nodo) {
                this.dict = {
                    "osc": (args) => osc(args),
                    "noise": (args) => noise(args),
                    "rotate": (args) => this.cadena.rotate(args),
                    "pixelate": (args) => this.cadena.pixelate(args),
                    // "out": (arg) => this.cadena.out(),
                    //el out se rompe 
                }
                this.cadena = this.dict[nodo]();

            }
            get val() {
                // console.log(this.cadena)
                return this.cadena;
            };
            ensamblador(name, args) {
                this.dict[name](args);
                return this;
            }
            out() {
                console.log("se supone q terminaria")
                this.cadena.out();
                console.log("no se rompio!")

            }
        }


        var test = new HydraFactory("osc");
        var listado = ["pixelate", "rotate"] //agregar un timmer ya sea calsico o con callback
        for (var i = 0; i < listado.length; i++) {
            test.ensamblador(listado[i]);
        }

        //test.ensamblador("pixelate").ensamblador("rotate");


        console.log(test)
        test.out()//.ensamblador("out")
        console.log(test)

        // var cierre = test.val;
        // cierre.out();
        //.out();

    </script>
</body>

</html>
